Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 44198)
@@ -1901,35 +1499,66 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
         }
-        
+
         @Override
+        public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
+            StringBuilder builder = new StringBuilder();
+            boolean first = true;
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
+                    continue;
+                }
+                if (first) {
+                    first = false;
+                } else {
+                    builder.append("; ");
+                }
+                builder.append(sql);
+            }
+            return builder.toString();
+        }
+
+        @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             StringBuilder builder = new StringBuilder();
             builder.append("CREATE ");
-            if( this.isUnique ) {
+            if (this.isUnique) {
                 builder.append("UNIQUE ");
             }
             builder.append("INDEX ");
-            if( this.ifNotExist ) {
+            if (this.ifNotExist) {
                 builder.append("IF NOT EXISTS ");
             }
-            builder.append(identifier(this.indexName));
+            builder.append(as_identifier(this.indexName));
             builder.append(" ON ");
-            builder.append(this.table.toString());
-            if( this.isSpatial ) {
+            builder.append(this.table.toString(formatter));
+            if (this.isSpatial) {
                 builder.append(" USING GIST ");
             }
             builder.append(" ( ");
             boolean is_first_column = true;
-            for( String column : this.columns) {
-                if( is_first_column ) {
+            for (String column : this.columns) {
+                if (is_first_column) {
                     is_first_column = false;
                 } else {
                     builder.append(", ");
@@ -1937,21 +1566,23 @@
                 builder.append(column);
             }
             builder.append(" )");
-            
+
             List<String> sqls = new ArrayList<>();
             sqls.add(builder.toString());
             return sqls;
         }
 
     }
-    
-    public class AlterTableBuilderBase implements AlterTableBuilder {
 
+    public class AlterTableBuilderBase
+            extends AbstractStatement
+            implements AlterTableBuilder {
+
         protected TableNameBuilder table;
         protected List<String> drops;
         protected List<ColumnDescriptor> adds;
         protected List<ColumnDescriptor> alters;
-        protected List<Pair<String,String>> renames;
+        protected List<Pair<String, String>> renames;
 
         public AlterTableBuilderBase() {
             this.drops = new ArrayList<>();
@@ -1962,25 +1593,25 @@
 
         @Override
         public boolean isEmpty() {
-            return this.drops.isEmpty() && 
-                this.adds.isEmpty() && 
-                this.alters.isEmpty() && 
-                this.renames.isEmpty();
+            return this.drops.isEmpty()
+                    && this.adds.isEmpty()
+                    && this.alters.isEmpty()
+                    && this.renames.isEmpty();
         }
-        
+
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
         }
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1991,11 +1622,11 @@
             this.drops.add(columnName);
             return this;
         }
-        
+
         @Override
         public AlterTableBuilder add_column(FeatureAttributeDescriptor fad) {
-            this.adds.add(column(fad).getDescriptor());
-            return this;            
+            this.adds.add(new ColumnDescriptorBase(fad));
+            return this;
         }
 
         @Override
@@ -2009,7 +1640,7 @@
 
         @Override
         public AlterTableBuilder add_geometry_column(String columnName, int type, int subtype, IProjection proj, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.adds.add(new ColumnDescriptorBase(columnName, type, subtype, proj, isIndexed, allowNulls));
@@ -2018,19 +1649,19 @@
 
         @Override
         public AlterTableBuilder add_geometry_column(String columnName, int type, int subtype, Object srsdbcode, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.adds.add(new ColumnDescriptorBase(columnName, type, subtype, srsdbcode, isIndexed, allowNulls));
             return this;
         }
-        
+
         @Override
         public AlterTableBuilder alter_column(FeatureAttributeDescriptor fad) {
-            this.alters.add(column(fad).getDescriptor());
-            return this;            
+            this.alters.add(new ColumnDescriptorBase(fad));
+            return this;
         }
-        
+
         @Override
         public AlterTableBuilder alter_column(String columnName, int type, int type_p, int type_s, boolean isPk, boolean isIndexed, boolean allowNulls, boolean isAutomatic, Object defaultValue) {
             if (isPk || isAutomatic) {
@@ -2042,7 +1673,7 @@
 
         @Override
         public AlterTableBuilder alter_geometry_column(String columnName, int type, int subtype, IProjection proj, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.alters.add(new ColumnDescriptorBase(columnName, type, subtype, proj, isIndexed, allowNulls));
@@ -2051,7 +1682,7 @@
 
         @Override
         public AlterTableBuilder alter_geometry_column(String columnName, int type, int subtype, Object srsdbcode, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.alters.add(new ColumnDescriptorBase(columnName, type, subtype, srsdbcode, isIndexed, allowNulls));
@@ -2066,10 +1697,18 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
-            for (String sql : toStrings()) {
-                if( StringUtils.isEmpty(sql) ) {
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
                     continue;
                 }
                 if (first) {
@@ -2084,36 +1723,41 @@
 
         @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
-            if( this.isEmpty() ) {
+            if (this.isEmpty()) {
                 return sqls;
             }
             for (String column : drops) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" DROP COLUMN IF EXISTS ");
-                builder.append(identifier(column)); 
+                builder.append(as_identifier(column));
                 sqls.add(builder.toString());
             }
             for (ColumnDescriptor column : adds) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" ADD COLUMN ");
-                builder.append(identifier(column.getName())); 
+                builder.append(as_identifier(column.getName()));
                 builder.append(" ");
-                if( column.getType() == DataTypes.INT && column.isAutomatic() ) {
+                if (column.getType() == DataTypes.INT && column.isAutomatic()) {
                     builder.append(" SERIAL");
                 } else {
                     builder.append(
-                        sqltype(
-                            column.getType(), 
-                            column.getPrecision(), 
-                            column.getSize(),
-                            column.getGeometryType(),
-                            column.getGeometrySubtype()
-                        )
+                            sqltype(
+                                    column.getType(),
+                                    column.getPrecision(),
+                                    column.getSize(),
+                                    column.getGeometryType(),
+                                    column.getGeometrySubtype()
+                            )
                     );
                 }
                 if (column.getDefaultValue() == null) {
@@ -2138,21 +1782,21 @@
             for (ColumnDescriptor column : alters) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" ALTER COLUMN ");
-                builder.append(identifier(column.getName())); 
+                builder.append(as_identifier(column.getName()));
                 builder.append(" SET DATA TYPE ");
-                if( column.getType() == DataTypes.INT && column.isAutomatic() ) {
+                if (column.getType() == DataTypes.INT && column.isAutomatic()) {
                     builder.append(" SERIAL");
                 } else {
                     builder.append(
-                        sqltype(
-                            column.getType(), 
-                            column.getPrecision(), 
-                            column.getSize(),
-                            column.getGeometryType(),
-                            column.getGeometrySubtype()
-                        )
+                            sqltype(
+                                    column.getType(),
+                                    column.getPrecision(),
+                                    column.getSize(),
+                                    column.getGeometryType(),
+                                    column.getGeometrySubtype()
+                            )
                     );
                 }
                 if (column.getDefaultValue() == null) {
@@ -2168,14 +1812,14 @@
                 }
                 sqls.add(builder.toString());
             }
-            for (Pair<String,String> pair : renames) {
+            for (Pair<String, String> pair : renames) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" RENAME COLUMN ");
-                builder.append(identifier(pair.getLeft())); 
+                builder.append(as_identifier(pair.getLeft()));
                 builder.append(" TO ");
-                builder.append(identifier(pair.getRight())); 
+                builder.append(as_identifier(pair.getRight()));
                 sqls.add(builder.toString());
             }
             return sqls;
@@ -2183,7 +1827,9 @@
 
     }
 
-    public class CreateTableBuilderBase implements CreateTableBuilder {
+    public class CreateTableBuilderBase
+            extends AbstractStatement
+            implements CreateTableBuilder {
 
         protected TableNameBuilder table;
         protected List<ColumnDescriptor> columns;
@@ -2194,17 +1840,17 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
         }
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -2212,13 +1858,13 @@
 
         @Override
         public CreateTableBuilderBase add_column(FeatureAttributeDescriptor fad) {
-            this.columns.add(column(fad).getDescriptor());
-            return this;            
+            this.columns.add(new ColumnDescriptorBase(fad));
+            return this;
         }
 
         @Override
         public CreateTableBuilderBase add_column(String columnName, int type, int type_p, int type_s, boolean isPk, boolean isIndexed, boolean allowNulls, boolean isAutomatic, Object defaultValue) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             if (isPk || isAutomatic) {
@@ -2230,7 +1876,7 @@
 
         @Override
         public CreateTableBuilder add_geometry_column(String columnName, int type, int subtype, IProjection proj, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.columns.add(new ColumnDescriptorBase(columnName, type, subtype, proj, isIndexed, allowNulls));
@@ -2239,7 +1885,7 @@
 
         @Override
         public CreateTableBuilder add_geometry_column(String columnName, int type, int subtype, Object srsdbcode, boolean isIndexed, boolean allowNulls) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
             }
             this.columns.add(new ColumnDescriptorBase(columnName, type, subtype, srsdbcode, isIndexed, allowNulls));
@@ -2248,23 +1894,31 @@
 
         @Override
         public ColumnDescriptor getColumnDescriptor(String columnName) {
-            if( StringUtils.isEmpty(columnName) ) {
+            if (StringUtils.isEmpty(columnName)) {
                 return null;
             }
             for (ColumnDescriptor column : columns) {
-                if( columnName.equals(column.getName()) ) {
+                if (columnName.equals(column.getName())) {
                     return column;
                 }
             }
             return null;
         }
-                
+
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
-            for (String sql : toStrings()) {
-                if( StringUtils.isEmpty(sql) ) {
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
                     continue;
                 }
                 if (first) {
@@ -2279,6 +1933,11 @@
 
         @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
             /**
              * CREATE [ [ GLOBAL | LOCAL ] { TEMPORARY | TEMP } ] TABLE
@@ -2308,7 +1967,7 @@
             StringBuilder builder = new StringBuilder();
 
             builder.append("CREATE TABLE ");
-            builder.append(this.table.toString());
+            builder.append(this.table.toString(formatter));
             builder.append(" (");
             boolean first = true;
             for (ColumnDescriptor column : columns) {
@@ -2317,14 +1976,21 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append(identifier(column.getName()));
+                builder.append(as_identifier(column.getName()));
                 builder.append(" ");
-                if( column.isAutomatic() && column.getType() == DataTypes.INT ) {
+                if (column.isAutomatic() && column.getType() == DataTypes.INT) {
                     builder.append("SERIAL");
-                } else if( column.isAutomatic() && column.getType() == DataTypes.LONG ) {
+                } else if (column.isAutomatic() && column.getType() == DataTypes.LONG) {
                     builder.append("BIGSERIAL");
                 } else {
-                    builder.append(sqltype(column.getType(), column.getPrecision(), column.getSize()));
+                    builder.append(sqltype(
+                            column.getType(),
+                            column.getPrecision(),
+                            column.getSize(),
+                            column.getGeometryType(),
+                            column.getGeometrySubtype()
+                    )
+                    );
                 }
                 if (column.getDefaultValue() == null) {
                     if (column.allowNulls()) {
@@ -2350,29 +2016,32 @@
         }
     }
 
-    public class InsertColumnBuilderBase implements InsertColumnBuilder {
+    public class InsertColumnBuilderBase
+            extends AbstractStatement
+            implements InsertColumnBuilder {
+
         protected Variable name;
         protected Value value;
-        
+
         public InsertColumnBuilderBase() {
         }
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.name != null ) {
+            if (this.name != null) {
                 this.name.accept(visitor, filter);
             }
-            if( this.value != null ) {
+            if (this.value != null) {
                 this.value.accept(visitor, filter);
             }
         }
 
         @Override
         public InsertColumnBuilder name(String name) {
-            this.name = variable(name);
+            this.name = expression().variable(name);
             return this;
         }
 
@@ -2381,25 +2050,35 @@
             this.value = value;
             return this;
         }
-        
+
         @Override
         public String getName() {
-            return this.name.getName();
+            return this.name.name();
         }
-        
+
         @Override
         public Value getValue() {
             return this.value;
         }
-        
+
         @Override
         public String toString() {
-            return this.value.toString();
+            return this.toString(formatter());
         }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
+            return this.value.toString(formatter);
+        }
     }
-    
-    public class InsertBuilderBase implements InsertBuilder {
 
+    public class InsertBuilderBase
+            extends AbstractStatement
+            implements InsertBuilder {
+
         protected List<InsertColumnBuilder> columns;
         protected TableNameBuilder table;
 
@@ -2409,10 +2088,10 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
             for (InsertColumnBuilder column : columns) {
@@ -2422,7 +2101,7 @@
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -2437,6 +2116,14 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             /*
              * INSERT INTO table [ ( column [, ...] ) ] { DEFAULT VALUES | VALUES (
              * { expression | DEFAULT } [, ...] ) [, ...] | query } [ RETURNING * |
@@ -2444,7 +2131,7 @@
              */
             StringBuilder builderColumns = new StringBuilder();
             StringBuilder builderValues = new StringBuilder();
-            
+
             boolean first = true;
             for (InsertColumnBuilder column : columns) {
                 if (first) {
@@ -2452,7 +2139,7 @@
                 } else {
                     builderColumns.append(", ");
                 }
-                builderColumns.append(identifier(column.getName()));
+                builderColumns.append(as_identifier(column.getName()));
             }
             first = true;
             for (InsertColumnBuilder column : columns) {
@@ -2461,12 +2148,12 @@
                 } else {
                     builderValues.append(", ");
                 }
-                builderValues.append(column.toString());
+                builderValues.append(column.toString(formatter));
             }
-            
+
             String sql = MessageFormat.format(
-                    config.getString(SQLConfig.INSERT_INTO_table_columns_VALUES_values),
-                    this.table.toString(),
+                    STMT_INSERT_INTO_table_columns_VALUES_values,
+                    this.table.toString(formatter),
                     builderColumns.toString(),
                     builderValues.toString()
             );
@@ -2475,23 +2162,25 @@
         }
     }
 
-    public class UpdateTableStatisticsBuilderBase implements UpdateTableStatisticsBuilder {
+    public class UpdateTableStatisticsBuilderBase
+            extends AbstractStatement
+            implements UpdateTableStatisticsBuilder {
 
         protected TableNameBuilder table;
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
         }
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -2499,10 +2188,18 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
-            for (String sql : toStrings()) {
-                if( StringUtils.isEmpty(sql) ) {
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
                     continue;
                 }
                 if (first) {
@@ -2517,14 +2214,19 @@
 
         @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
-            
-            if( config.has_functionality(SQLConfig.UPDATE_TABLE_STATISTICS_table) ) {
+
+            if (!StringUtils.isBlank(STMT_UPDATE_TABLE_STATISTICS_table)) {
                 String sql = MessageFormat.format(
-                        config.getString(SQLConfig.UPDATE_TABLE_STATISTICS_table),
-                        table.toString()
-                    );
-                if( !StringUtils.isEmpty(sql) ) {
+                        STMT_UPDATE_TABLE_STATISTICS_table,
+                        table.toString(formatter)
+                );
+                if (!StringUtils.isEmpty(sql)) {
                     sqls.add(sql);
                 }
             }
